PiecewiseYoYInflationCurve< Interpolator, Bootstrap, Traits > Class Template Reference

Piecewise year-on-year inflation term structure. More...

`#include <ql/termstructures/inflation/piecewiseyoyinflationcurve.hpp>`

Inheritance diagram for PiecewiseYoYInflationCurve< Interpolator, Bootstrap, Traits >:
[legend]

## Public Types

typedef Traits | traits_type
typedef Interpolator | interpolator_type
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Public Member Functions

Constructors
| PiecewiseYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, const Period &lag, Frequency frequency, bool indexIsInterpolated, Rate baseYoYRate, const std::vector< ext::shared_ptr< typename Traits::helper > > &instruments, Real accuracy=1.0e-12, const Interpolator &i=Interpolator())
QL_DEPRECATED | PiecewiseYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, const Period &lag, Frequency frequency, bool indexIsInterpolated, Rate baseYoYRate, const Handle< YieldTermStructure > &nominalTS, const std::vector< ext::shared_ptr< typename Traits::helper > > &instruments, Real accuracy=1.0e-12, const Interpolator &i=Interpolator())
Inflation interface
Date | baseDate () const
| minimum (base) date More...
Date | maxDate () const
| the latest date for which the curve can return values
Inspectors
const std::vector< Time > & | times () const
const std::vector< Date > & | dates () const
const std::vector< Real > & | data () const
std::vector< std::pair< Date, Real > > | nodes () const
Public Member Functions inherited from InterpolatedYoYInflationCurve< Interpolator >
| InterpolatedYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, const Period &lag, Frequency frequency, bool indexIsInterpolated, const std::vector< Date > &dates, const std::vector< Rate > &rates, const Interpolator &interpolator=Interpolator())
QL_DEPRECATED | InterpolatedYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yTS, const std::vector< Date > &dates, const std::vector< Rate > &rates, const Interpolator &interpolator=Interpolator())
const std::vector< Date > & | dates () const
const std::vector< Time > & | times () const
const std::vector< Real > & | data () const
const std::vector< Rate > & | rates () const
std::vector< std::pair< Date, Rate > > | nodes () const
Public Member Functions inherited from YoYInflationTermStructure
| YoYInflationTermStructure (const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
| YoYInflationTermStructure (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
| YoYInflationTermStructure (Natural settlementDays, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | YoYInflationTermStructure (const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yieldTS, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | YoYInflationTermStructure (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yieldTS, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | YoYInflationTermStructure (Natural settlementDays, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yieldTS, const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
Rate | yoyRate (const Date &d, const Period &instObsLag=Period(-1, Days), bool forceLinearInterpolation=false, bool extrapolate=false) const
| year-on-year inflation rate. More...
Rate | yoyRate (Time t, bool extrapolate=false) const
| year-on-year inflation rate. More...
Public Member Functions inherited from InflationTermStructure
| InflationTermStructure (Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
| InflationTermStructure (const Date &referenceDate, Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const Calendar &calendar=Calendar(), const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
| InflationTermStructure (Natural settlementDays, const Calendar &calendar, Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | InflationTermStructure (Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yTS, const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | InflationTermStructure (const Date &referenceDate, Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yTS, const Calendar &calendar=Calendar(), const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
QL_DEPRECATED | InflationTermStructure (Natural settlementDays, const Calendar &calendar, Rate baseRate, const Period &observationLag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yTS, const DayCounter &dayCounter=DayCounter(), const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
virtual Period | observationLag () const
virtual Frequency | frequency () const
virtual bool | indexIsInterpolated () const
virtual Rate | baseRate () const
virtual Handle< YieldTermStructure > | nominalTermStructure () const
void | setSeasonality (const ext::shared_ptr< Seasonality > &seasonality=ext::shared_ptr< Seasonality >())
| Functions to set and get seasonality. More...
ext::shared_ptr< Seasonality > | seasonality () const
bool | hasSeasonality () const
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~TermStructure ()
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled
Public Member Functions inherited from LazyObject
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()

## Observer interface

class | Bootstrap< this_curve >
class | BootstrapError< this_curve >
void | update ()

## Additional Inherited Members

Protected Member Functions inherited from InterpolatedYoYInflationCurve< Interpolator >
Rate | yoyRateImpl (Time t) const
| to be defined in derived classes
| InterpolatedYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Interpolator &interpolator=Interpolator())
QL_DEPRECATED | InterpolatedYoYInflationCurve (const Date &referenceDate, const Calendar &calendar, const DayCounter &dayCounter, Rate baseYoYRate, const Period &lag, Frequency frequency, bool indexIsInterpolated, const Handle< YieldTermStructure > &yTS, const Interpolator &interpolator=Interpolator())
Protected Member Functions inherited from YoYInflationTermStructure
Protected Member Functions inherited from InflationTermStructure
virtual void | setBaseRate (const Rate &r)
void | checkRange (const Date &, bool extrapolate) const
void | checkRange (Time t, bool extrapolate) const
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Member Functions inherited from InterpolatedCurve< Interpolator >
| InterpolatedCurve (const std::vector< Time > &times, const std::vector< Real > &data, const Interpolator &i=Interpolator())
| InterpolatedCurve (const std::vector< Time > &times, const Interpolator &i=Interpolator())
| InterpolatedCurve (Size n, const Interpolator &i=Interpolator())
| InterpolatedCurve (const Interpolator &i=Interpolator())
| InterpolatedCurve (const InterpolatedCurve &c)
InterpolatedCurve & | operator= (const InterpolatedCurve &c)
void | setupInterpolation ()
Protected Member Functions inherited from LazyObject
virtual void | calculate () const
Protected Attributes inherited from InterpolatedYoYInflationCurve< Interpolator >
std::vector< Date > | dates_
Protected Attributes inherited from InflationTermStructure
ext::shared_ptr< Seasonality > | seasonality_
Period | observationLag_
Frequency | frequency_
bool | indexIsInterpolated_
Rate | baseRate_
Handle< YieldTermStructure > | nominalTermStructure_
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_
Protected Attributes inherited from InterpolatedCurve< Interpolator >
std::vector< Time > | times_
std::vector< Real > | data_
Interpolation | interpolation_
Interpolator | interpolator_
Date | maxDate_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Detailed Description

### template<class Interpolator, template< class > class Bootstrap = IterativeBootstrap, class Traits = YoYInflationTraits>
class QuantLib::PiecewiseYoYInflationCurve< Interpolator, Bootstrap, Traits >

Piecewise year-on-year inflation term structure.

## Constructor & Destructor Documentation

## PiecewiseYoYInflationCurve()

QL_DEPRECATED PiecewiseYoYInflationCurve | ( | const Date & | referenceDate,
|  | const Calendar & | calendar,
|  | const DayCounter & | dayCounter,
|  | const Period & | lag,
|  | Frequency | frequency,
|  | bool | indexIsInterpolated,
|  | Rate | baseYoYRate,
|  | const Handle< YieldTermStructure > & | nominalTS,
|  | const std::vector< ext::shared_ptr< typename Traits::helper > > & | instruments,
|  | Real | accuracy = `1.0e-12`,
|  | const Interpolator & | i = `Interpolator()`
| ) |  |

Deprecated:
  Use the constructor not taking a yield term structure. Deprecated in version 1.19.

## Member Function Documentation

## baseDate()

Date baseDate | ( |  | ) | const

virtual

minimum (base) date

Important in inflation since it starts before nominal reference date. Changes depending whether index is interpolated or not. When interpolated the base date is just observation lag before nominal. When not interpolated it is the beginning of the relevant period (hence it is easy to create interpolated fixings from a not-interpolated curve because interpolation, usually, of fixings is forward looking).

Reimplemented from InterpolatedYoYInflationCurve< Interpolator >.

## update()

void update | ( |  | ) |

virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Reimplemented from LazyObject.